"use strict";

exports.__esModule = true;
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _offsetCoordinates = require("./offsetCoordinates");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var withRelativeMousePos = function withRelativeMousePos(key) {
  if (key === void 0) {
    key = 'relativeMousePos';
  }

  return function (DecoratedComponent) {
    var WithRelativeMousePos = /*#__PURE__*/function (_Component) {
      _inheritsLoose(WithRelativeMousePos, _Component);

      function WithRelativeMousePos() {
        var _this;

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _Component.call.apply(_Component, [this].concat(args)) || this;

        _defineProperty(_assertThisInitialized(_this), "state", {
          x: null,
          y: null
        });

        _defineProperty(_assertThisInitialized(_this), "innerRef", function (el) {
          _this.container = el;
        });

        _defineProperty(_assertThisInitialized(_this), "onMouseMove", function (e) {
          var xystate = (0, _offsetCoordinates.getOffsetCoordPercentage)(e, _this.container);

          _this.setState(xystate);
        });

        _defineProperty(_assertThisInitialized(_this), "onTouchMove", function (e) {
          if (e.targetTouches.length === 1) {
            var touch = e.targetTouches[0];
            var offsetX = touch.pageX - _this.container.offsetParent.offsetLeft;
            var offsetY = touch.pageY - _this.container.offsetParent.offsetTop;

            _this.setState({
              x: offsetX / _this.container.width * 100,
              y: offsetY / _this.container.height * 100
            });
          }
        });

        _defineProperty(_assertThisInitialized(_this), "onMouseLeave", function (e) {
          _this.setState({
            x: null,
            y: null
          });
        });

        _defineProperty(_assertThisInitialized(_this), "onTouchLeave", function (e) {
          _this.setState({
            x: null,
            y: null
          });
        });

        return _this;
      }

      var _proto = WithRelativeMousePos.prototype;

      _proto.render = function render() {
        var _hocProps;

        var hocProps = (_hocProps = {}, _hocProps[key] = {
          innerRef: this.innerRef,
          onMouseMove: this.onMouseMove,
          onMouseLeave: this.onMouseLeave,
          onTouchMove: this.onTouchMove,
          onTouchLeave: this.onTouchLeave,
          x: this.state.x,
          y: this.state.y
        }, _hocProps);
        return /*#__PURE__*/_react["default"].createElement(DecoratedComponent, _extends({}, this.props, hocProps));
      };

      return WithRelativeMousePos;
    }(_react.PureComponent);

    WithRelativeMousePos.displayName = "withRelativeMousePos(" + DecoratedComponent.displayName + ")";
    return WithRelativeMousePos;
  };
};

var _default = withRelativeMousePos;
exports["default"] = _default;
module.exports = exports.default;